%define libname %mklibname %{name} 0
%define develname %mklibname %{name} -d

%define with_prelude 0
%{?_without_prelude: %{expand: %%global with_prelude 0}}
%{?_with_prelude: %{expand: %%global with_prelude 1}}

%define bootstrap 0
%{?_without_bootstrap: %global bootstrap 0}
%{?_with_bootstrap: %global bootstrap 1}

%define pam_redhat_version 0.99.10-1

Summary:	A security tool which provides authentication for applications
Name:		pam
Version:	1.1.8
%define subrel	2
Release:	%mkrel 7
# The library is BSD licensed with option to relicense as GPLv2+ - this option is redundant
# as the BSD license allows that anyway. pam_timestamp and pam_console modules are GPLv2+,
License:	BSD and GPLv2+
Group:		System/Libraries
Url:		http://www.linux-pam.org/
Source0:	http://www.linux-pam.org/library/Linux-PAM-%{version}.tar.bz2
Source1:	%{name}-tmpfiles.conf
Source2:	pam-redhat-%{pam_redhat_version}.tar.bz2
Source5:	other.pamd
Source6:	system-auth.pamd
Source7:	config-util.pamd
Source8:	dlopen.sh
Source9:	system-auth.5
Source10:	config-util.5
Source11:	90-nproc.conf
Source12:	postlogin.pamd
Source13:	postlogin.5

# RedHat patches
Patch1:  pam-1.0.90-redhat-modules.patch
Patch2:  pam-1.1.6-std-noclose.patch
Patch4:  pam-1.1.0-console-nochmod.patch
Patch5:  pam-1.1.0-notally.patch
Patch7:  pam-1.1.0-console-fixes.patch
Patch9:  pam-1.1.6-noflex.patch
Patch10: pam-1.1.3-nouserenv.patch
Patch11: pam-1.1.3-console-abstract.patch
Patch13: pam-1.1.5-limits-user.patch
Patch22: pam-1.1.7-unix-build.patch
Patch32: pam-1.1.7-tty-audit-init.patch
Patch35: pam-1.1.8-cve-2013-7041.patch
Patch36: pam-1.1.8-cve-2014-2583.patch
Patch44: pam-1.2.0-password-limit.patch

# Mageia specific sources/patches
# (fl) fix infinite loop
Patch507:	pam-0.74-loop.patch
# (fc) don't complain when / is owned by root.adm
Patch508:	Linux-PAM-0.99.3.0-pamtimestampadm.patch
# (fl) pam_xauth: set extra groups because in high security levels
#      access to /usr/X11R6/bin dir is controlled by a group
Patch512:	Linux-PAM-1.1.1-xauth-groups.patch
# (blino) fix parallel build (pam_console)
Patch521:	Linux-PAM-0.99.3.0-pbuild-rh.patch

Patch700:	pam_fix_static_pam_console.patch
# (fc) do not output error when no file is in /etc/security/console.perms.d/
Patch701:	pam-1.1.0-console-nopermsd.patch
# (peroyvind): add missing constant that went with rpc removal from glibc 2.14
Patch702:	Linux-PAM-1.1.4-add-now-missing-nis-constant.patch

#add missing documentation
Source501: 	pam_tty_audit.8
Source502:	README
Requires(pre):	filesystem >= 2.1.9-18
Requires(posttrans):	systemd >= %{systemd_required_version}
Requires:	cracklib-dicts
Requires:	setup >= 2.7.12-2
Requires:	pam_tcb >= 1.0.2-16
Conflicts:	initscripts < 3.94
Requires(pre):	rpm-helper
Requires(posttrans):	coreutils
Requires(posttrans):	tcb >= 1.0.2-16
BuildRequires:	bison cracklib-devel flex
%if !%{bootstrap}
# this pulls in the mega texlive load
BuildRequires:	linuxdoc-tools
%endif
BuildRequires:	db5_nss-devel
BuildRequires:	openssl-devel
BuildRequires:	libaudit-devel
BuildRequires:	glibc-crypt_blowfish-devel
BuildRequires:	gettext-devel
%if %with_prelude
BuildRequires:	prelude-devel >= 0.9.0
%else
BuildConflicts:	prelude-devel
%endif

%description
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication.

%package	doc
Summary:	Additional documentation for %{name}
Group:		System/Libraries
Requires:	%{name} = %{version}
BuildArch:	noarch

%description	doc
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication.

This is the documentation package of %{name}.

%package -n	%{libname}
Summary:	Libraries for %{name}
Group:		System/Libraries
Requires(pre):	filesystem >= 2.1.9-18

%description -n	%{libname}
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication.

This package contains the librairies for %{name}.

%package -n	%{develname}
Summary:	Development headers and libraries for %{name}
Group:		Development/Other
Requires(pre):	filesystem >= 2.1.9-18
Requires:	%{libname} = %{version}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}

%description -n	%{develname}
PAM (Pluggable Authentication Modules) is a system security tool that
allows system administrators to set authentication policy without
having to recompile programs that handle authentication.

This package contains the development librairies for %{name}.

%prep
%setup -q -n Linux-PAM-%{version} -a 2

# Add custom modules.
mv pam-redhat-%{pam_redhat_version}/* modules

# (RH)
%patch1 -p1 -b .redhat-modules
%patch2 -p1 -b .std-noclose
%patch4 -p1 -b .nochmod
%patch5 -p1 -b .notally
%patch7 -p1 -b .console-fixes
%patch9 -p1 -b .noflex
%patch10 -p1 -b .nouserenv
%patch11 -p1 -b .abstract
%patch13 -p1 -b .limits
%patch22 -p1 -b .build
%patch32 -p1 -b .tty-audit-init
%patch35 -p1 -b .case
%patch36 -p1 -b .timestamp-ruser
%patch44 -p1 -b .password-limit

# (Mageia)
%patch507 -p1 -b .loop
%patch508 -p1 -b .pamtimestampadm
%patch512 -p0 -b .xauth-groups
%patch521 -p1 -b .pbuild-rh
%patch700 -p1 -b .static
%patch701 -p1 -b .nopermsd
%patch702 -p1 -b .nis-const

# 08/08/2008 - vdanen - make pam provide pam_unix until we can work out all the issues in pam_tcb; this
# just makes things easier but is not meant to be a permanent solution
## Remove unwanted modules; pam_tcb provides pam_unix now
#for d in pam_unix; do
#    rm -rf modules/$d
#    sed -i "s,modules/$d/Makefile,," configure.in
#    sed -i "s/ $d / /" modules/Makefile.am
#done


install -m644 %{SOURCE501} %{SOURCE502} modules/pam_tty_audit/

mkdir -p doc/txts
for readme in modules/pam_*/README ; do
	cp -f ${readme} doc/txts/README.`dirname ${readme} | sed -e 's|^modules/||'`
done

%build
autoreconf -fi -I m4

export BROWSER=""
CFLAGS="$RPM_OPT_FLAGS -fPIC -I%{_includedir}/db_nss -D_GNU_SOURCE" \
%configure2_5x \
	--includedir=%{_includedir}/security \
	--with-db-uniquename=_nss \
	--docdir=%{_docdir}/%{name} \
	--disable-selinux
%make

%install
mkdir -p %{buildroot}%{_includedir}/security
mkdir -p %{buildroot}%{_libdir}/security
%makeinstall_std LDCONFIG=:
install -d -m 755 %{buildroot}/etc/pam.d
install -m 644 %{SOURCE5} %{buildroot}/etc/pam.d/other
install -m 644 %{SOURCE6} %{buildroot}/etc/pam.d/system-auth
install -m 644 %{SOURCE7} %{buildroot}/etc/pam.d/config-util
install -m 644 %{SOURCE11} %{buildroot}%{_sysconfdir}/security/limits.d/90-nproc.conf
install -m 644 %{SOURCE12} %{buildroot}/etc/pam.d/postlogin
install -m 600 /dev/null %{buildroot}%{_sysconfdir}/security/opasswd
install -d -m 755 %{buildroot}/var/log
install -m 600 /dev/null %{buildroot}/var/log/tallylog

# Install man pages.
install -m 644 %{SOURCE9} %{SOURCE10} %{SOURCE13} %{buildroot}%{_mandir}/man5/

# Install tmpfiles
install -D -p -m 644 %{SOURCE1} %{buildroot}%{_tmpfilesdir}/%{name}.conf

# remove unpackaged .la files
rm -rf %{buildroot}%{_libdir}/*.la %{buildroot}%{_libdir}/security/*.la

# no longer needed, handled by ACL in udev
for phase in auth acct passwd session ; do	 
	ln -sf pam_unix.so %{buildroot}%{_libdir}/security/pam_unix_${phase}.so	 
done

%find_lang Linux-PAM

%check
# (blino) we don't want to test if SE Linux is built, it's disabled
# Make sure every module subdirectory gave us a module.  Yes, this is hackish.
for dir in modules/pam_* ; do
if [ -d ${dir} ] && [ ${dir} != "modules/pam_selinux" && [ ${dir} != "modules/pam_sepermit"  ]; then
         [ ${dir} = "modules/pam_tally" ] && continue
	if ! ls -1 %{buildroot}%{_libdir}/security/`basename ${dir}`*.so ; then
		echo ERROR `basename ${dir}` did not build a module.
		exit 1
	fi
fi
done

# Check for module problems.  Specifically, check that every module we just
# installed can actually be loaded by a minimal PAM-aware application.
%{_sbindir}/ldconfig -n %{buildroot}%{_libdir}
for module in %{buildroot}%{_libdir}/security/pam*.so ; do
	if ! env LD_LIBRARY_PATH=%{buildroot}%{_libdir} \
		 %{SOURCE8} -ldl -lpam -L%{buildroot}%{_libdir} ${module} ; then
		echo ERROR module: ${module} cannot be loaded.
		exit 1
	fi
done

rmdir %{buildroot}/var/run/console

%posttrans
%_tmpfilescreate %{name}
# (cg) Ensure that the pam_systemd.so is included for user ACLs under systemd
# Note: Only affects upgrades, but does no harm so always update if needed.
if ! grep -q "pam_systemd\.so" /etc/pam.d/system-auth; then
  echo "-session    optional      pam_systemd.so" >>/etc/pam.d/system-auth
fi

if [ ! -a /var/log/tallylog ] ; then
       install -m 600 /dev/null /var/log/tallylog
fi
if [ -f /etc/login.defs ] && ! grep -q USE_TCB /etc/login.defs; then
       %{_sbindir}/set_tcb --auto --migrate
fi


%files -f Linux-PAM.lang
%doc NEWS
%docdir %{_docdir}/%{name}
%dir /etc/pam.d
%config(noreplace) /etc/environment
%config(noreplace) /etc/pam.d/other
%attr(0644,root,shadow) %config(noreplace) /etc/pam.d/system-auth
%config(noreplace) /etc/pam.d/config-util
%config(noreplace) /etc/pam.d/postlogin
%{_sbindir}/mkhomedir_helper
%{_sbindir}/pam_console_apply
%{_sbindir}/pam_tally2
%{_sbindir}/unix_chkpwd
%{_sbindir}/unix_update
%attr(4755,root,root) %{_sbindir}/pam_timestamp_check
%{_tmpfilesdir}/%{name}.conf
%config(noreplace) %{_sysconfdir}/security/access.conf
%config(noreplace) %{_sysconfdir}/security/chroot.conf
%config(noreplace) %{_sysconfdir}/security/console.perms
%config(noreplace) %{_sysconfdir}/security/console.handlers
%config(noreplace) %{_sysconfdir}/security/group.conf
%config(noreplace) %{_sysconfdir}/security/limits.conf
%dir %{_sysconfdir}/security/limits.d
%config(noreplace) %{_sysconfdir}/security/limits.d/90-nproc.conf
%config(noreplace) %{_sysconfdir}/security/namespace.conf
%attr(755,root,root) %config(noreplace) %{_sysconfdir}/security/namespace.init
%config(noreplace) %{_sysconfdir}/security/pam_env.conf
%config(noreplace) %{_sysconfdir}/security/time.conf
%config(noreplace) %{_sysconfdir}/security/opasswd
%dir %{_sysconfdir}/security/console.apps
%dir %{_sysconfdir}/security/console.perms.d
%ghost %verify(not md5 size mtime) /var/log/tallylog
%{_mandir}/man5/*
%{_mandir}/man8/*

%files -n %{libname}
%{_libdir}/libpam.so.*
%{_libdir}/libpamc.so.*
%{_libdir}/libpam_misc.so.*
%{_libdir}/security/*.so
%{_libdir}/security/pam_filter
%dir %{_libdir}/security

%files -n %{develname}
%doc Copyright
%{_libdir}/libpam.so
%{_libdir}/libpam_misc.so
%{_libdir}/libpamc.so
%{_includedir}/security/*.h
%{_mandir}/man3/*

%files doc
%doc doc/txts doc/specs/rfc86.0.txt Copyright


%changelog
* Wed Jul 01 2015 luigiwalser <luigiwalser> 1.1.8-7.2.mga4
+ Revision: 849402
- add patch from fedora to fix CVE-2015-3238
- add patches from fedora to fix CVE-2013-7041 and CVE-2014-2583

* Thu Jan 23 2014 luigiwalser <luigiwalser> 1.1.8-7.mga4
+ Revision: 567549
- raise process limit to 4096 in accordance with fedora (mga#11550)

* Wed Oct 30 2013 luigiwalser <luigiwalser> 1.1.8-6.mga4
+ Revision: 548041
- remove process limit for root user (rhbz#432903)

* Tue Oct 29 2013 tv <tv> 1.1.8-5.mga4
+ Revision: 547791
- really move systemd %%post in %%posttrans (trying to fix install deps loop errors)

* Tue Oct 29 2013 tv <tv> 1.1.8-4.mga4
+ Revision: 547767
- move systemd %%post in %%posttrans (trying to fix install deps loop errors)

* Mon Oct 21 2013 umeabot <umeabot> 1.1.8-3.mga4
+ Revision: 539135
- Mageia 4 Mass Rebuild

* Fri Oct 04 2013 luigiwalser <luigiwalser> 1.1.8-2.mga4
+ Revision: 491497
- pam_tty_audit: proper initialization of the tty_audit_status struct (from fedora)

* Wed Oct 02 2013 luigiwalser <luigiwalser> 1.1.8-1.mga4
+ Revision: 490526
- 1.1.8

* Fri Sep 13 2013 luigiwalser <luigiwalser> 1.1.7-1.mga4
+ Revision: 478711
- 1.1.7
- remove upstreamed patches 21 and 24
- update patch 22 (from fedora)

* Mon Jul 29 2013 luigiwalser <luigiwalser> 1.1.6-6.mga4
+ Revision: 460178
- add postlogin config (from fedora), needed by passwd 0.79

* Sun Mar 24 2013 colin <colin> 1.1.6-5.mga3
+ Revision: 405136
- Use tmpfiles macros and add system version to requires (mga#9302)

* Sun Mar 10 2013 luigiwalser <luigiwalser> 1.1.6-4.mga3
+ Revision: 402037
- prevent logged-in users from running fork bombs (rhbz#432903)
- add support for tmpfs mount options in pam_namespace (from fedora)

* Sun Jan 13 2013 umeabot <umeabot> 1.1.6-3.mga3
+ Revision: 362361
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Jan 09 2013 cjw <cjw> 1.1.6-2.mga3
+ Revision: 343442
- add BuildRequires: gettext-devel
- fix build with automake 1.13

* Mon Sep 03 2012 luigiwalser <luigiwalser> 1.1.6-1.mga3
+ Revision: 287431
- 1.1.6
- update URLs
- resync some patches from fedora

* Tue Jul 31 2012 fwang <fwang> 1.1.5-4.mga3
+ Revision: 276295
- rebuild for db-5.3

* Wed Jul 25 2012 fwang <fwang> 1.1.5-3.mga3
+ Revision: 274190
- build with db 5.2

* Mon Jul 23 2012 colin <colin> 1.1.5-2.mga3
+ Revision: 273694
- Move to /usr
- Fix build with glibc-2.16 (patch from Arch)
- Ensure that /run/console directory is created via tmpfiles

* Sun Feb 19 2012 luigiwalser <luigiwalser> 1.1.5-1.mga2
+ Revision: 210662
- 1.1.5
- remove upstreamed security patches
- fix URL
- various cleanups from mdv:
  - work around ordering issue by moving %%post script to %%posttrans
  - check if /etc/login.defs exists before trying to open it in scriplet
  - spec cleanups
  - add bootstrap option to avoid texlive
  - add patch for missing nis constant removed from glibc (patch 702)

* Tue Jan 17 2012 colin <colin> 1.1.3-7.mga2
+ Revision: 197402
- Fix typo in post script (systemd auth issues mga#4134

* Sun Jan 08 2012 colin <colin> 1.1.3-6.mga2
+ Revision: 193519
- Ensure pam_systemd is included in system-auth (mga#3822)

  + anssi <anssi>
    - fix USE_TCB check in %%post to avoid running the migration script every
      time (from Mandriva)

* Fri Nov 11 2011 colin <colin> 1.1.3-5.mga2
+ Revision: 166528
- Fix CVE-2011-3148, CVE-2011-3149 relating to overflows in pam_env. mga#3192

* Wed Nov 09 2011 colin <colin> 1.1.3-4.mga2
+ Revision: 165866
- Drop default rt prio/nice values for members of the audio group. mga#2503
- Add optional pam_systemd to system-auth session.
   * This is quite safe even when dealing with non-systemd systems
     as it is both optional in the session sense, and is prefixed by -
     thus not breaking things when pam_systemd.so is not installed.
     The module itself deals gracefully when systemd is used for boot
     or not (the latter being a noop)

* Tue Jan 11 2011 pterjan <pterjan> 1.1.3-2.mga1
+ Revision: 6072
- Remove removed file from file list

  + blino <blino>
    - remove old readme files
    - update comment
    - remove old comments, ldconfig scripts, version checks, conflicts, obsoletes
    - imported package pam

